#import "LabelEx.h"

//LabeExの実装
@implementation LabelEx

//ラベルの生成
- (UILabel*)makeLabel:(CGPoint)pos text:(NSString*)text font:(UIFont*)font {
    //文字列の幅と高さの取得(1)
    CGSize size=[text sizeWithFont:font];
    CGRect rect=CGRectMake(pos.x,pos.y,size.width,size.height);

    //ラベルの生成(2)
    UILabel* label=[[[UILabel alloc] init] autorelease];         
    [label setFrame:rect];    
    [label setText:text];
    [label setFont:font];
    [label setTextColor:[UIColor blackColor]];
    [label setTextAlignment:NSTextAlignmentLeft];
    [label setNumberOfLines:0];
    [label setLineBreakMode:NSLineBreakByWordWrapping];
    [label setBackgroundColor:[UIColor clearColor]];
    return label;
}

//イメージビューの生成(4)
- (UIImageView*)makeImageView:(CGRect)rect image:(UIImage*)image {
    UIImageView* imageView=[[[UIImageView alloc] init] autorelease];
    [imageView setFrame:rect];
    [imageView setImage:image];
    return imageView;
}

//初期化
- (void)viewDidLoad {
    [super viewDidLoad];
        
    //ラベルの生成
    UILabel* label=[self makeLabel:CGPointMake(0,0) 
        text:@"これはテストです" 
        font:[UIFont systemFontOfSize:16]];
    
    //コンポーネントの配置(3)
    [self.view addSubview:label];
        
    //イメージビューの生成
    UIImageView* imageView=[self makeImageView:
        CGRectMake(0,50,80,80)
        image:[UIImage imageNamed:@"sample.png"]];

    //コンポーネントの配置(3)
    [self.view addSubview:imageView];
}
@end