#import "MapViewEx.h"

//MapViewExの実装
@implementation MapViewEx

//初期化
- (void)viewDidLoad {
    [super viewDidLoad];
        
    //マップビューの生成(1)
    _mapView=[[MKMapView alloc] init];
    [_mapView setFrame:self.view.frame];
    [_mapView setMapType:MKMapTypeStandard];
    [_mapView setDelegate:self];
    [self.view addSubview:_mapView];

    //ビューサイズの自動調整
    _mapView.autoresizingMask= 
         UIViewAutoresizingFlexibleRightMargin| 
         UIViewAutoresizingFlexibleTopMargin|
         UIViewAutoresizingFlexibleLeftMargin|
         UIViewAutoresizingFlexibleBottomMargin|
         UIViewAutoresizingFlexibleWidth|
         UIViewAutoresizingFlexibleHeight;

    //位置の値の用意(2)
    CLLocationCoordinate2D coordinate;
    coordinate.latitude =35.707527;
    coordinate.longitude=139.760857;

    //ズームの値の用意(3)
    MKCoordinateSpan span;
    span.latitudeDelta =0.01;
    span.longitudeDelta=0.01;
  
    //ズームと位置の指定(4)
    MKCoordinateRegion region;
    region.center=coordinate;
    region.span  =span;
    [_mapView setRegion:region animated:YES];
}

//メモリ解放
- (void)dealloc {
    [_mapView release];
    [super dealloc];
}

//マップロード成功時に呼ばれる(5)
- (void)mapViewDidFinishLoadingMap:(MKMapView*)mapView {
    NSLog(@"マップロード成功");
}

//マップロード失敗時に呼ばれる(5)
- (void)mapViewDidFailLoadingMap:(MKMapView*)mapView 
    withError:(NSError*)error {
    NSLog(@"マップロード失敗");   
}
@end
