#import "AppDelegate.h"
#import "BackgroundTaskEx.h"

//AppDelegateの実装
@implementation AppDelegate

//プロパティの実装
@synthesize window=_window;

//アプリ起動時に呼ばれる
- (BOOL)application:(UIApplication*)application
didFinishLaunchingWithOptions:(NSDictionary*)launchOptions {
    //ウィンドウの生成
    _window=[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    [_window makeKeyAndVisible];
    
    //ビューコントローラの生成
    UIViewController* viewCtl=[[[BackgroundTaskEx alloc] init] autorelease];
    _window.rootViewController=viewCtl;
    return YES;
}

//メモリの解放
- (void)dealloc {
    [_window release];
    [super dealloc];
}

//バックグラウンド遷移時に呼ばれる
- (void)applicationDidEnterBackground:(UIApplication*)application {
    //バックグラウンドタスクの開始(1)
    UIApplication* app=[UIApplication sharedApplication];
    _bgTask=[app beginBackgroundTaskWithExpirationHandler:^{
        //バックグラウンドタスクの終了(2)
        [app endBackgroundTask:_bgTask];
        _bgTask=UIBackgroundTaskInvalid;
    }];
    dispatch_async(dispatch_get_global_queue(
        DISPATCH_QUEUE_PRIORITY_DEFAULT,0), ^{
        //バックグラウンドタスクの記述
        NSLog(@"バックグラウンドタスクの処理を記述");
        
        //ローカルノーティフィケーションの表示(3)
        UILocalNotification* notification=
            [[[UILocalNotification alloc] init] autorelease];
        notification.alertBody=@"バックグラウンドタスクの処理が完了";
        [app presentLocalNotificationNow:notification];
        
        //バックグラウンドタスクの終了(2)
        [app endBackgroundTask:_bgTask];
        _bgTask=UIBackgroundTaskInvalid;
    });
}
@end
