#import "BackgroundTaskEx.h"

//BackgroundTaskExの実装
@implementation BackgroundTaskEx

//ラベルの生成
- (UILabel*)makeLabel:(CGPoint)pos text:(NSString*)text font:(UIFont*)font {
    //文字列の幅と高さの取得
    CGSize size=[text sizeWithFont:font];
    CGRect rect=CGRectMake(pos.x,pos.y,size.width,size.height);
    
    //ラベルの生成
    UILabel* label=[[[UILabel alloc] init] autorelease];
    [label setFrame:rect];
    [label setText:text];
    [label setFont:font];
    [label setTextColor:[UIColor blackColor]];
    [label setTextAlignment:NSTextAlignmentLeft];
    [label setNumberOfLines:0];
    [label setLineBreakMode:NSLineBreakByWordWrapping];
    [label setBackgroundColor:[UIColor clearColor]];
    return label;
}

//初期化
- (void)viewDidLoad {
    [super viewDidLoad];
    
    //ラベルの生成
    UILabel* label=[self makeLabel:CGPointMake(0,0)
        text:@"BackgroundEx"
        font:[UIFont systemFontOfSize:16]];
    [self.view addSubview:label];
}
@end